#import "BTDevice.h"
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

#import <CoreFoundation/CoreFoundation.h>
#import <CoreGraphics/CGContext.h>
#import <UIKit/UIKit.h>
#import <UIKit/UITextView.h>
#import <UIKit/UIFont.h>
#import <NSGraphicsContext.h>
#import "showFlow.h"

#include <btstack/btstack.h>
#include <btstack/run_loop.h>
#include <btstack/hci_cmds.h>
#include <BTstackManager.h>

int main(int argc, char *argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    int retVal = UIApplicationMain(argc, argv, @"showFlow", @"showFlow");
	[pool release];
	return retVal;
}

@implementation showFlow
char tmp[255];
int nb=0;
int received=0;
-(void) rfcommConnectionCreatedAtAddress:(bd_addr_t)addr forChannel:(uint16_t)channel asID:(uint16_t)connectionID{
}
-(void) rfcommConnectionCreateFailedAtAddress:(bd_addr_t)addr forChannel:(uint16_t)channel error:(BTstackError)error{}
-(void) rfcommConnectionClosedForConnectionID:(uint16_t)connectionID{}
-(void) rfcommDataReceivedForConnectionID:(uint16_t)connectionID withData:(uint8_t *)packet ofLen:(uint16_t)size{
	//if (!strncmp((char*)packet,"val:",4)){
	memcpy(tmp+nb,packet,size);
	nb+=size;
	if ((packet[size-1] == '\0')||(packet[size-1] == '\n')){
	NSString *valp = [[NSString alloc] initWithFormat:@"%d",received];
    [rfStat performSelectorOnMainThread:@selector(setText:)
            withObject: valp
            waitUntilDone:YES];
	received++;
	NSString *str = [[NSString alloc] initWithCString:(char*)tmp encoding : 1];
    [rfStat performSelectorOnMainThread:@selector(setText:)
            withObject: str
            waitUntilDone:YES];
	NSString *str2 = [[NSString alloc] initWithCString:(char*)tmp+4 encoding : 1];
	CGFloat val = [str2 doubleValue];
	[affSin addPoint: val];
	nb = 0;
	}
}



/* Event when a device is selected */
-(BOOL) discoveryView:(BTDiscoveryViewController*)discoveryView willSelectDeviceAtIndex:(int)deviceIndex {
    if (selectedDevice) return NO;
    selectedDevice = [bt deviceAtIndex:deviceIndex];
    BTDevice *device = selectedDevice;
    [bt stopDiscovery];
	[bt createRFCOMMConnectionAtAddress:[device address] withChannel:11 authenticated:NO];
	[nav.view removeFromSuperview];
	//[bt removeListener:inqView];
    return NO;
}
-(void) statusCellSelectedDiscoveryView:(BTDiscoveryViewController*)discoveryView {
    if (![bt isDiscoveryActive]) {
        selectedDevice = nil;
        [bt startDiscovery];
    }
    NSLog(@"statusCellSelected!");
}

- (void)applicationDidFinishLaunching:(UIApplication *)application {    
	selectedDevice = nil;
	window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
	// create BTInquiryView
	inqView = [[BTDiscoveryViewController alloc] init];
	[inqView setDelegate:self];
    // Override point for customization after application launch
	nav = [[UINavigationController alloc] initWithRootViewController:inqView];


    CGRect windowRect = [ [ UIScreen mainScreen ] applicationFrame ];
    windowRect.origin.x = windowRect.origin.y = 0.0f;
    CGRect imgRect2 = CGRectMake(0,0,windowRect.size.width,
								windowRect.size.height);
    affSin = [[afficheSinu alloc] initWithFrame: imgRect2];
	[affSin setLineWidth:5];
	affSin.nbPoints=1000;

    CGRect txtFrame2 = CGRectMake(110,65,250,150);
    CGRect txtFrame1 = CGRectMake(90,65,250,150);
    UIFont *font = [UIFont boldSystemFontOfSize:18.0];
	CGAffineTransform rotation = CGAffineTransformRotate(CGAffineTransformIdentity, 
						(90.0/180.0 * M_PI));
    rfStat = [[UITextField alloc] initWithFrame:txtFrame2];
	rfStat.textColor = [UIColor colorWithRed:1 green:1 blue:1 alpha:1];
    rfStat.text = @"testGPS";
    rfStat.font = font;
	rfStat.transform = rotation;
    nbElem = [[UITextField alloc] initWithFrame:txtFrame1];
	nbElem.textColor = [UIColor colorWithRed:1 green:1 blue:1 alpha:1];
    nbElem.text = @"nbElem";
    nbElem.font = font;
	nbElem.transform = rotation;



    [window addSubview:affSin];
    [window addSubview:rfStat];
    [window addSubview:nbElem];
	[window addSubview:nav.view];
	[window makeKeyAndVisible];

	// btstack
	bt = [BTstackManager sharedInstance];
	[bt setDelegate:self];
	[bt addListener:self];
	[bt addListener:inqView];
		
	[bt activate];
}

- (void)dealloc {
    [window release];
    [super dealloc];
}
-(void) activatedBTstackManager:(BTstackManager*) manager {}
-(void) btstackManager:(BTstackManager*)manager activationFailed:(BTstackError)error {};
-(void) discoveryInquiryBTstackManager:(BTstackManager*) manager {
    [bt storeDeviceInfo];
}
-(void) discoveryStoppedBTstackManager:(BTstackManager*) manager {}
-(void) btstackManager:(BTstackManager*)manager discoveryQueryRemoteName:(int)deviceIndex {}
-(void) btstackManager:(BTstackManager*)manager deviceInfo:(BTDevice*)device{}

-(void) btstackManager:(BTstackManager*) manager handlePacketWithType:(uint8_t) packet_type forChannel:(uint16_t) channel
               andData:(uint8_t *)packet withLen:(uint16_t) size {
}
@end
